#ifndef PATCHER_H
#define PATCHER_H
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "../include/global.h"
#include "../include/utilities.h"
#include "../include/file_operations.h"
#include "../include/meta_explorer.h"
#include "../include/partcutdesc_generator.h"
#include "../include/paz_browser.h"
#include "../include/size_patcher.h"


void runPatcher(FileBlock* fileBlocks, MetaFileInfo* metaFileInfo,PatcherState* patcherOptions);
void markFilesToPatch(FileBlock* filesToPatch, int* filesToPatchCount, FileBlock* fileBlocks, MetaFileInfo* metaFileInfo, PatcherState* patcherState);
void addToFilesToPatch(FileBlock* fileBlockFound, FileBlock* filesToPatch, int* filesToPatchCount);

void patchMetaFile(FileBlock* filesToPatch, int filesToPatchCount, int operation, MetaFileInfo* metaFileInfo, int echo);
void copyPatcherResourcesFiles(FileBlock* filesToPatch, int filesToPatchCount, PatcherState* patcherState);
void modifyXMLFiles(FileBlock* filesToPatch, long filesToPatchCount, PatcherState* patcherState);

char*** getStarters();
//int isStockingTexture(char* fileName);
void copyNudeTextures(PatcherState* patcherState);
int isRegular(char* fileName);
int isANudeTexture(char* fileName);
void validatePatcherResourcesFiles(FileBlock* fileBlocks, MetaFileInfo* metaFileInfo);
void printFileBeingCopied(FileBlock* fileToPatch,long filesToPatchCount, char** newclass_prefix, char** old_class_prefix, int i);
int bodyPartsSizeChanged(PatcherState* patcherState);
void weaponOptionRequirePatch(FileBlock* fileBlock, PatcherState* patcherState);
int isATreeDummerFile(char* fileName);
void patchFromFile(int operation, FileBlock* fileBlocks, MetaFileInfo* metaFileInfo);


#endif

