#ifndef PAZ_BROWSER_H
#define PAZ_BROWSER_H
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include "../include/utilities.h"
#include "../include/meta_explorer.h"
#include "../include/partcutdesc_generator.h"


extern int MAX_FILE_NAME_LENGTH;
extern int MAX_LINES;
extern int MAX_ROWS;

void compensateLength(char* fileName, int longestLength);
int getCursorRow(int cursorPos);
int getCursorLine(int cursorPos);
void nextPage(int* pageStart, int* pageEnd, int nOptions);
void previousPage(int* pageStart, int* pageEnd);
void goToPage(int pageNum, int* pageStart, int* pageEnd, int nOptions);
void goToLastPage(int* pageStart, int* pageEnd, int nOptions);
int getCurrentPage(int cursor,int nOptions);
int getTotalPages(int nOptions);
char* getClassFolderPrefix(char* classSelected);
char* getPartFolderPrefix(char* partSelected);
char* getClassPrefixFromMenuOption(char* classSelected);
char* getPartPrefixFromMenuOption(char* partSelected);
char* menuSelectClass(int* classSelected_idx);
char* menuSelectPart(int* partSelected_idx);
FileBlock* menuSelectFile(char* classSelected,char* partSelected,char* fileExt, FileBlock* fileBlocks, MetaFileInfo* metaFileInfo, int operation);
void previewFile(FileBlock* fileBlockSelected, FileBlock* fileBlocks, MetaFileInfo* metaFileInfo);
int runPazBrowser(FileBlock* fileBlocks, MetaFileInfo *metaFileInfo, char* operationName, int operation);
void uiMenuSelectFile(FileBlock** filesOnMenu,int nOptions, int cursor, int pageStart, int pageEnd, int operation, int selectAll, MetaFileInfo* metaFileInfo);
void uiMenuSelectFileColor(FileBlock** filesOnMenu,int nOptions, int cursor, int pageStart, int pageEnd, int operation, int selectAll, MetaFileInfo* metaFileInfo);
#endif // PAZ_BROWSER_H
