#include "../include/partcutdesc_generator.h"

void generatePartcutdesc(FileBlock* fileBlocks, MetaFileInfo* metaFileInfo)
{
    if (!fileBlocks)
    {
        printf("\nFailed to alocate FileBlocks\n");
        system("PAUSE");
        exit(1);
    }

    int j = 0;


    printf("\nGenerating partcutdesc.xml file...");
    createPath(concatenate(bdoRootFolder(),"character\\"));
    FILE* partcutdesc = openFile(concatenate(bdoRootFolder(),"character\\partcutdesc.xml"), "wb");

    int classAllowed[13];
    for (j = 0; j < TOTAL_CLASSES; j++)
    {
        classAllowed[j] = 1;
    }

    createCutTypeBlock("Underwear","38_Underwear",classAllowed,partcutdesc,metaFileInfo,fileBlocks);
    createCutTypeBlock("Event","Event_costume",classAllowed,partcutdesc,metaFileInfo,fileBlocks);

    classAllowed[PEW] = 0;
    classAllowed[PWM] = 0;
    classAllowed[PWW] = 0;
    classAllowed[PHW] = 0;
    classAllowed[PBW] = 0;
    createCutTypeBlock("Upperbody","9_Upperbody",classAllowed,partcutdesc,metaFileInfo,fileBlocks);

    for (j = 0; j < TOTAL_CLASSES; j++)
    {
        classAllowed[j] = 0;
    }
    classAllowed[PEW] = 1;
    classAllowed[PWM] = 1;
    classAllowed[PWW] = 1;
    createCutTypeBlock("PEW_Upperbody","9_Upperbody",classAllowed,partcutdesc,metaFileInfo,fileBlocks);

    for (j = 0; j < TOTAL_CLASSES; j++)
    {
        classAllowed[j] = 0;
    }
    classAllowed[PHW] = 1;
    createCutTypeBlock("PHW_Upperbody02","9_Upperbody",classAllowed,partcutdesc,metaFileInfo,fileBlocks);

    for (j = 0; j < TOTAL_CLASSES; j++)
    {
        classAllowed[j] = 0;
    }
    classAllowed[PBW] = 1;
    createCutTypeBlock("PBW_Upperbody05","9_Upperbody",classAllowed,partcutdesc,metaFileInfo,fileBlocks);


    for (j = 0; j < TOTAL_CLASSES; j++)
    {
        classAllowed[j] = 1;
    }
    classAllowed[PBW] = 0;
    classAllowed[PWM] = 0;
    classAllowed[PDW] = 0;
    classAllowed[PWW] = 0;
    createCutTypeBlock("Hand","11_Hand",classAllowed,partcutdesc,metaFileInfo,fileBlocks);

    for (j = 0; j < TOTAL_CLASSES; j++)
    {
        classAllowed[j] = 0;
    }
    classAllowed[PBW] = 1;
    classAllowed[PWM] = 1;
    classAllowed[PWW] = 1;
    createCutTypeBlock("PBW_Hand05","11_Hand",classAllowed,partcutdesc,metaFileInfo,fileBlocks);

    for (j = 0; j < TOTAL_CLASSES; j++)
    {
        classAllowed[j] = 1;
    }
    createCutTypeBlock("Lowerbody","10_Lowerbody",classAllowed,partcutdesc,metaFileInfo,fileBlocks);
    createCutTypeBlock("Foot","12_Foot",classAllowed,partcutdesc,metaFileInfo,fileBlocks);
    createCutTypeBlock("Hel","13_Hel",classAllowed,partcutdesc,metaFileInfo,fileBlocks);
    createCutTypeBlock("Hair","Hair",classAllowed,partcutdesc,metaFileInfo,fileBlocks);


    for (j = 0; j < TOTAL_CLASSES; j++)
    {
        classAllowed[j] = 0;
    }
    classAllowed[PHM] = 1;
    classAllowed[PNM] = 1;
    createCutTypeBlock("Sho","14_Sho",classAllowed,partcutdesc,metaFileInfo,fileBlocks);

    for (j = 0; j < TOTAL_CLASSES; j++)
    {
        classAllowed[j] = 1;
    }
    createCutTypeBlock("EnchantArm","28_EnchantArm",classAllowed,partcutdesc,metaFileInfo,fileBlocks);

    for (j = 0; j < TOTAL_CLASSES; j++)
    {
        classAllowed[j] = 0;
    }
    classAllowed[PHW] = 1;
    createCutTypeBlock("PHW_Sho02","14_Sho",classAllowed,partcutdesc,metaFileInfo,fileBlocks);

    for (j = 0; j < TOTAL_CLASSES; j++)
    {
        classAllowed[j] = 0;
    }
    classAllowed[PBW] = 1;
    classAllowed[PEW] = 1;
    classAllowed[PVW] = 1;
    classAllowed[PWW] = 1;
    classAllowed[PDW] = 1;
    classAllowed[PKWW] = 1;
    classAllowed[PNW] = 1;
    createCutTypeBlock("PBW_Sho","14_Sho",classAllowed,partcutdesc,metaFileInfo,fileBlocks);

    printf("\nDone.\n");

    printf("\nExtracting original partcutdesc file:\n");

    char* command = (char*) malloc (strlen("cd patcher_resources & quickbms.exe -Y -f \"*partcutdesc.xml*\" blackdesert.bms ../PAD00001.PAZ ./") + 1);
    sprintf(command,"cd patcher_resources & quickbms.exe -Y -f \"*partcutdesc.xml*\" blackdesert.bms ../PAD00001.PAZ ./");
    system(command);
    free(command);

    printf("\n\nModifying original partcutdesc.xml...\n");


    MemFile* originalPartCutDescMem = copyFileToMemoryByName("patcher_resources\\character\\partcutdesc.xml");

    FileBlock* partCutDescBlock = NULL;

    int i = 0;
    for (i = 0; i < metaFileInfo->fileBlocksCount; i++)
    {
        if (fileBlocks[i].needPatch == 1)
        {
            int start = 0;
            int end = 0;
            if (containsStartEnd(originalPartCutDescMem->bytes,fileBlocks[i].fileName,&start,&end))
            {
                printColor("Removed",YELLOW);printf(" - %s\n", fileBlocks[i].fileName);
                originalPartCutDescMem->bytes[start-4] = '<';
                originalPartCutDescMem->bytes[start-3] = '!';
                originalPartCutDescMem->bytes[start-2] = '-';
                originalPartCutDescMem->bytes[start-1] = '-';

                originalPartCutDescMem->bytes[end-1] = '>';
                originalPartCutDescMem->bytes[end-2] = '-';
                originalPartCutDescMem->bytes[end-3] = '-';
            }
        }


        if (strcmpi(fileBlocks[i].fileName,"partcutdesc.xml") == 0)
        {
            partCutDescBlock = &fileBlocks[i];
        }
    }
    printf("Done.\n");
    printf("\nMerging original and created partcutdesc.xml files...");

    FILE* originalPartCutDescFile = fopen("patcher_resources\\character\\partcutdesc.xml","wb");

    for (i = 0; i < originalPartCutDescMem->size; i++)
    {
        fwrite(&originalPartCutDescMem->bytes[i],1,1,partcutdesc);
        fwrite(&originalPartCutDescMem->bytes[i],1,1,originalPartCutDescFile);
    }
    fclose(originalPartCutDescFile);
    printf("\nDone.");



    if (partCutDescBlock == NULL)
    {
        printf("\nError: partcutdesc.xml not found in File Blocks\n");
        PAUSE();
    }
    else
    {
        partCutDescBlock->needPatch = 1;

        // Apply patch: partcutdesc.xml
         patchMetaFile(partCutDescBlock, 1, REMOVE_A_FILE, metaFileInfo,1);
    }
    partCutDescBlock->needPatch = 0;

    float fileSize = (float)getFileSizeByName(concatenate(bdoRootFolder(),"character\\partcutdesc.xml"));
    fileSize /= 1000.0;

    if (fileSize < 100.0)
    {
        printf("\nSomething went wrong, your partcutdesc.xml file should have at least 100kb and it has %.2f", fileSize);
    }
    else
    {
        printf("\nCompleted!\n\npartcutdesc.xml file size: %.2fkb", fileSize);
    }
    free(originalPartCutDescMem->bytes);
    fclose(partcutdesc);
}

void writestr(char* str,FILE* fp)
{
    fwrite(str,strlen(str),1,fp);
}

char* cutTypeOpenTag(char* label)
{
    char* tag = (char*) malloc(256);
    strcpy(tag,"<CutType Name=\"");
    strcat(tag,label);
    strcat(tag,"\">\n");
    return tag;
}

char* basicCutTypeOpenTag(char* label)
{
    char* tag = (char*) malloc(256);
    strcpy(tag,"<BasicCutType Name=\"");
    strcat(tag,label);
    strcat(tag,"\">\n");
    return tag;
}

char* getFileBlockFullPath(FileBlock fileBlock)
{
    return concatenate(substr(fileBlock.folderName,strlen("character/model/"),strlen(fileBlock.folderName)),fileBlock.fileName);
}

void addToPartCutDesc(FileBlock fileBlock, FILE* partcutdesc)
{
    char* fileOpenTag1 = "\t<File>";
    char* fileCloseTag1 = "</File>\n";
    char* fileOpenTag2 = "\t<!-- <File>";
    char* fileCloseTag2 = "</File> -->\n";
    if(strcmpi(getFileExt(fileBlock.fileName),"pac") == 0)
     {
         if (fileBlock.needPatch == 1)
         {
            writestr(fileOpenTag2,partcutdesc);
         }
         else
         {
             writestr(fileOpenTag1,partcutdesc);
         }

         writestr(getFileBlockFullPath(fileBlock),partcutdesc);

         if (fileBlock.needPatch == 1)
         {
            writestr(fileCloseTag2,partcutdesc);
            printColor("\nRemoved",YELLOW);printf(" - %s", fileBlock.fileName);
         }
         else
         {
             writestr(fileCloseTag1,partcutdesc);
         }
     }
}
void createCutTypeBlock(char* blockName,char* compareFolderName,int* classAllowed, FILE* partcutdesc, MetaFileInfo* metaFileInfo,FileBlock* fileBlocks)
{
    int i = 0;
    ///int skip = 0;

    writestr(cutTypeOpenTag(blockName), partcutdesc);
    for (i = 0; i < metaFileInfo->fileBlocksCount; i++)
    {
        ///skip = 0;

         if (strcmpi(getLastFolder(fileBlocks[i].folderName),compareFolderName) == 0)
         {
             char* classPrefix = getClassPrefix(fileBlocks[i].fileName);

            if (classAllowed[PHM])
            {
                if (strcmpi(classPrefix,"phm") == 0)
                {
                    addToPartCutDesc(fileBlocks[i], partcutdesc);
                }
            }
            if (classAllowed[PHW])
            {
                if (strcmpi(classPrefix,"phw") == 0)
                {
                    addToPartCutDesc(fileBlocks[i], partcutdesc);
                }
            }
            if (classAllowed[PEW])
            {
                if (strcmpi(classPrefix,"pew") == 0)
                {
                    addToPartCutDesc(fileBlocks[i], partcutdesc);
                }
            }
            if (classAllowed[PGM])
            {
                if (strcmpi(classPrefix,"pgm") == 0)
                {
                    addToPartCutDesc(fileBlocks[i], partcutdesc);
                }
            }
            if (classAllowed[PBW])
            {
                if (strcmpi(classPrefix,"pbw") == 0)
                {
                    addToPartCutDesc(fileBlocks[i], partcutdesc);
                }
            }
            if (classAllowed[PKM])
            {
                if (strcmpi(classPrefix,"pkm") == 0)
                {
                    addToPartCutDesc(fileBlocks[i], partcutdesc);
                }
            }
            if (classAllowed[PVW])
            {
                if (strcmpi(classPrefix,"pvw") == 0)
                {
                    addToPartCutDesc(fileBlocks[i], partcutdesc);
                }
            }
            if (classAllowed[PWM])
            {
                if (strcmpi(classPrefix,"pwm") == 0)
                {
                    addToPartCutDesc(fileBlocks[i], partcutdesc);
                }
            }
            if (classAllowed[PWW])
            {
                if (strcmpi(classPrefix,"pww") == 0)
                {
                    addToPartCutDesc(fileBlocks[i], partcutdesc);
                }
            }
            if (classAllowed[PHM])
            {
                if (strcmpi(classPrefix,"phm") == 0)
                {
                    addToPartCutDesc(fileBlocks[i], partcutdesc);
                }
            }
            if (classAllowed[PNW])
            {
                if (strcmpi(classPrefix,"pnw") == 0)
                {
                    addToPartCutDesc(fileBlocks[i], partcutdesc);
                }
            }
            if (classAllowed[PNM])
            {
                if (strcmpi(classPrefix,"pnm") == 0)
                {
                    addToPartCutDesc(fileBlocks[i], partcutdesc);
                }
            }
            if (classAllowed[PDW])
            {
                if (strcmpi(classPrefix,"pdw") == 0)
                {
                    addToPartCutDesc(fileBlocks[i], partcutdesc);
                }
            }
            if (classAllowed[PKWW])
            {
                if (contains(classPrefix,"pkw"))
                {
                    addToPartCutDesc(fileBlocks[i], partcutdesc);
                }
            }
         }
    }
    writestr("</CutType>\n\n",partcutdesc);
}
