#include "../include/paz_browser.h"

int MAX_FILE_NAME_LENGTH = 29;
int MAX_LINES = 15;
int MAX_ROWS = 3;

char* menuSelectClass(int* cursor)
{
    MenuElements menu;
    menu.nOptions = 12;
    strcpy(menu.header,"Select a class:");
    strcpy(menu.menuoptions[0],"Warrior");
    strcpy(menu.menuoptions[1],"Sorceress");
    strcpy(menu.menuoptions[2],"Ranger");
    strcpy(menu.menuoptions[3],"Berserker");
    strcpy(menu.menuoptions[4],"Tamer");
    strcpy(menu.menuoptions[5],"Blader(Musa)");
    strcpy(menu.menuoptions[6],"Valkyrie");
    strcpy(menu.menuoptions[7],"Wizard");
    strcpy(menu.menuoptions[8],"Witch");
    strcpy(menu.menuoptions[9],"Kunoichi");
    strcpy(menu.menuoptions[10],"Ninja");
    strcpy(menu.menuoptions[11],"Dark Knight");
    strcpy(menu.menuoptions[12],"Plum(Maehwa)");


    return createArrowMenu(menu, cursor);
}

char* menuSelectPart(int* cursor)
{
    MenuElements menu;
    menu.nOptions = 11;
    strcpy(menu.header,"Select a part:");
    strcpy(menu.menuoptions[0],"Upperbody");
    strcpy(menu.menuoptions[1],"Lowerbody");
    strcpy(menu.menuoptions[2],"Hand");
    strcpy(menu.menuoptions[3],"Foot");
    strcpy(menu.menuoptions[4],"Helmet");
    strcpy(menu.menuoptions[5],"Shoulder");
    strcpy(menu.menuoptions[6],"Cloak");
    strcpy(menu.menuoptions[7],"Underwear");
    strcpy(menu.menuoptions[8],"Event Costume");
    strcpy(menu.menuoptions[9],"Body Mesh");
    strcpy(menu.menuoptions[10],"Head");
    strcpy(menu.menuoptions[11],"Weapons");


    return createArrowMenu(menu,cursor);
}

char* menuSelectExt()
{
    char input = '\0';

    while(1)
    {
        system("cls");
        printMainHeader();
        printf("Choose which type of files you want to browse:\n");
        printf("1 - PAC files     \n");
        printf("2 - Texture Files \n");
        printf("0 - Go Back \n");

        printf("\n");
        printf("Enter your choice: ");

        scanf("%c", &input);

        if (input == '1')
        {
            return "pac";
        }
        if (input == '2')
        {
            return "dds";
        }

        if (input == '0')
        {
            return "Back";
        }
    }
    return "Back";
}

int shouldDisplayFile(FileBlock* fileBlock, char* classFolderPrefix, char* partFolderPrefix, char* classPrefix, char*  partPrefix, char* fileExt)
{
    if (fileBlock->fileName[0] != 'p' || !fileHasExt(fileBlock->fileName,fileExt))
    {
        return 0;
    }
    if (contains(fileBlock->folderName,"weapon") && contains(fileBlock->folderName,"0_com"))
    {
        return 0;
    }
    if ((contains(fileBlock->folderName,classFolderPrefix)) && (contains(fileBlock->folderName,partFolderPrefix)) && fileHasExt(fileBlock->fileName,"pac"))
    {
        return 1;
    }
    else if (fileHasExt(fileBlock->fileName,"dds"))
    {
        if (contains(fileBlock->fileName,classPrefix) && contains(fileBlock->fileName, partPrefix))
        {
            int skip = 0;

            if (contains(fileBlock->fileName,"contribute") && strcmpi(partPrefix,"event_costume") != 0)
            {
                return 0;
            }

            if (skip == 0)
            {
                return 1;
            }
        }
        else if (((strcmpi(partPrefix,"_uw_") == 0) && fileHasExt(fileBlock->fileName,"dds")) || contains(fileBlock->fileName,"_99_"))
        {
            if (isStockingTexture(fileBlock->fileName))
            {
                return 1;
            }
        }
    }

    return 0;
}


FileBlock* menuSelectFile(char* classSelected,char* partSelected,char* fileExt, FileBlock* fileBlocks, MetaFileInfo* metaFileInfo, int operation)
{
    char* classFolderPrefix = getClassFolderPrefix(classSelected);
    char* partFolderPrefix = getPartFolderPrefix(partSelected);

    char* classPrefix = getClassPrefixFromMenuOption(classSelected);
    char* partPrefix = getPartPrefixFromMenuOption(partSelected);

    int i = 0;
    long nOptions = 0;
    int cursor = 0;
    int pageStart = 0;
    int pageEnd = MAX_LINES* MAX_ROWS;

    int selectAll = 0;
    char input = '\0';


    FileBlock** filesOnMenu = NULL;

    for (i = 0; i < metaFileInfo->fileBlocksCount; i++)
    {
        if (shouldDisplayFile(&fileBlocks[i], classFolderPrefix, partFolderPrefix, classPrefix, partPrefix, fileExt))
        {
            nOptions++;
        }
    }


    if (nOptions == 0)
    {
        printf("\n No files to display.");
        PAUSE();
    }

    filesOnMenu = (FileBlock**) malloc((nOptions + 1) * sizeof(FileBlock*));

    int currentMenuOption = 0;
    for (i = 0; i < metaFileInfo->fileBlocksCount; i++)
    {
        if (shouldDisplayFile(&fileBlocks[i], classFolderPrefix, partFolderPrefix, classPrefix, partPrefix, fileExt))
        {
            filesOnMenu[currentMenuOption] = &fileBlocks[i];
            currentMenuOption++;
        }
    }




    while(1)
    {

        if (isWindows10)
        {
            uiMenuSelectFileColor(filesOnMenu, nOptions, cursor, pageStart, pageEnd, operation,selectAll, metaFileInfo);
        }
        else
        {
            uiMenuSelectFile(filesOnMenu, nOptions, cursor, pageStart, pageEnd, operation,selectAll, metaFileInfo);
        }

        input = getch();

        if (input == ENTER ||  input == 10)
        {
            if (operation == GET_TEXTURES)
            {
                extractTexturesFrom(filesOnMenu[cursor],fileBlocks,metaFileInfo);
                PAUSE();
            }
            else
            {
                int skip = 0;
                int filesToPatchCount = 0;
                 for(i = 0; i < metaFileInfo->fileBlocksCount; i++)
                 {
                     if (fileBlocks[i].needPatch == 1)
                     {
                         filesToPatchCount++;
                     }
                 }


                if (filesToPatchCount == 0)
                {
                    printf("\nWarning: No files were selected to patch.");
                    printf("\nMake sure you use SPACE or R to mark the files");
                    printf("\n\nDo you want to proceed or you want to go back and change your settings first?\n");
                    printf("ENTER = Proceed    ESC = Go Back\n");
                    char c = '\0';

                    while(c != ENTER &&  c != 10 && c != ESC)
                    {
                        c = getch();
                    }
                    if (c == ESC)
                    {
                        skip = 1;
                    }
                }

                if (skip == 0)
                {
                    save_paz_browser_patcher_state(fileBlocks,metaFileInfo,operation);

                    if (operation == FIX_HOLES)
                    {
                        generatePartcutdesc(fileBlocks,metaFileInfo);
                        PAUSE();
                    }
                    else if (operation == REMOVE_A_FILE)
                    {
                        printf("\n\nCopy files...\n");
                        copyBlankFiles(fileBlocks,metaFileInfo);
                        patchMetaFile(fileBlocks,metaFileInfo->fileBlocksCount,REMOVE_A_FILE,metaFileInfo,1);
                        filesPatched = countPatchedFiles(fileBlocks,metaFileInfo);
                        PAUSE();
                    }
                    else if (operation == RESTORE_A_FILE)
                    {
                        patchMetaFile(fileBlocks,metaFileInfo->fileBlocksCount,RESTORE_A_FILE,metaFileInfo,1);
                        filesPatched = countPatchedFiles(fileBlocks,metaFileInfo);
                        PAUSE();
                    }
                    else if (operation == GET_TEXTURES)
                    {

                    }
                 }
            }
        }
        if (operation != GET_TEXTURES)
        {
            if (input == SPACE)
            {
                filesOnMenu[cursor]->needPatch = !filesOnMenu[cursor]->needPatch;
                if (filesOnMenu[cursor]->needPatch == 0)
                {
                    filesOnMenu[cursor]->changeID = 0;
                }
                else
                {
                    filesOnMenu[cursor]->changeID = 1;
                }
            }

            if (input == 'L' || input == 'l')
            {
                previewFile(filesOnMenu[cursor],fileBlocks,metaFileInfo);
            }
            else if (input == 'r' || input == 'R')
            {
                char confirmation = '\0';
                printf("\nAre you sure you want to UNMARK all files?\n");
                printf("(Warning: Your file \"%s\" will be deleted)\n\n", PAZ_BROWSER_PATCHER_STATE_FILE_NAME[operation]);
                printf("   ENTER = Proceed    ESC = Go Back\n");
                while(confirmation != ENTER && confirmation != 10 && confirmation != ESC)
                {
                    confirmation = getch();
                }
                if (confirmation == ENTER || confirmation == 10)
                {
                    clearFileBlocks(fileBlocks,metaFileInfo);
                    remove(concatenate("patcher_resources\\", PAZ_BROWSER_PATCHER_STATE_FILE_NAME[operation]));
                    printf("\nAll Files have been Unmarked.");
                    Sleep(1500);
                }
            }

            else if (input == 'c' || input == 'C')
            {
                if (filesOnMenu[cursor]->needPatch == 0)
                {
                    for (i = 0; i < metaFileInfo->fileBlocksCount; i++)
                    {
                        if (contains(fileBlocks[i].fileName,removeClassPrefix(filesOnMenu[cursor]->fileName)))
                        {
                            fileBlocks[i].needPatch = 1;
                            fileBlocks[i].changeID = 2;
                        }
                    }
                }
                else if (filesOnMenu[cursor]->needPatch == 1 )
                {
                    for (i = 0; i < metaFileInfo->fileBlocksCount; i++)
                    {
                        if (contains(fileBlocks[i].fileName,removeClassPrefix(filesOnMenu[cursor]->fileName)))
                        {
                            fileBlocks[i].needPatch = 0;
                            fileBlocks[i].changeID = 0;
                        }
                    }
                }
            }

            else if (input == 'g' || input == 'G')
            {
                if (filesOnMenu[cursor]->needPatch == 0)
                {
                    for (i = 0; i < metaFileInfo->fileBlocksCount; i++)
                    {
                        if (haveTheSameGender(fileBlocks[i].fileName, filesOnMenu[cursor]->fileName) && contains(fileBlocks[i].fileName,removeClassPrefix(filesOnMenu[cursor]->fileName)))
                        {
                            fileBlocks[i].needPatch = 1;
                            if (isAFemaleFile(filesOnMenu[cursor]->fileName))
                            {
                                fileBlocks[i].changeID = 3;
                            }
                            else
                            {
                                fileBlocks[i].changeID = 4;
                            }

                        }
                    }
                }
                else if (filesOnMenu[cursor]->needPatch == 1 )
                {
                    for (i = 0; i < metaFileInfo->fileBlocksCount; i++)
                    {
                        if (haveTheSameGender(fileBlocks[i].fileName, filesOnMenu[cursor]->fileName) && contains(fileBlocks[i].fileName,removeClassPrefix(filesOnMenu[cursor]->fileName)))
                        {
                            fileBlocks[i].needPatch = 0;
                            fileBlocks[i].changeID = 0;
                        }
                    }
                }
            }
            else if (input == 'a' || input == 'A')
            {


                for (i = 0; i < nOptions; i++)
                {
                    if (selectAll == 0)
                    {
                        filesOnMenu[i]->needPatch = 1;
                        filesOnMenu[i]->changeID = 1;
                    }
                    else
                    {
                        filesOnMenu[i]->needPatch = 0;
                        filesOnMenu[i]->changeID = 0;
                    }

                }
                 selectAll = !selectAll;
            }
        }
        if (input == ESC)
        {
             resizeWindow(120,30);
            return NULL;
        }
        if (input == PAGE_UP)
        {
            nextPage(&pageStart,&pageEnd,nOptions);
            cursor = pageStart;
        }
        if (input == PAGE_DOWN)
        {
            previousPage(&pageStart,&pageEnd);
            cursor = pageStart;
        }
        if (input == ARROW_DOWN)
        {
            if( cursor + 1 < nOptions)
            {
                cursor++;
            }
            if (cursor >= pageEnd)
            {
                nextPage(&pageStart,&pageEnd,nOptions);
            }
        }
        if (input == ARROW_UP)
        {
            if (cursor - 1 >= 0)
            {
                cursor--;
            }
            if (cursor < pageStart)
            {
                previousPage(&pageStart,&pageEnd);
            }
        }
        else if (input == ARROW_RIGHT)
        {
            if (cursor + MAX_LINES < nOptions)
            {
                cursor += MAX_LINES;
            }
            if (cursor >= pageEnd)
            {
                nextPage(&pageStart,&pageEnd,nOptions);
            }
        }
        if (input == ARROW_LEFT)
        {
            if (cursor - MAX_LINES >= 0)
            {
                cursor -= MAX_LINES;
            }
              if (cursor < pageStart)
            {
                previousPage(&pageStart,&pageEnd);
            }
        }
    }

    resizeWindow(120,30);
    return 0;
}



int runPazBrowser(FileBlock* fileBlocks, MetaFileInfo *metaFileInfo, char* operationName, int operation)
{

    int classSelected_idx = 0;
    int partSelected_idx = 0;
    if(!isWindows10)
    {
       // MAX_ROWS = 2;
       MAX_FILE_NAME_LENGTH = 22;
    }

    // CLEAR FILE BLOCKS
    clearFileBlocks(fileBlocks,metaFileInfo);


    if (operation != GET_TEXTURES)
    {
        int i = 0;
        int j = 0;

        int paz_browser_patcher_state_n_files = 0;
        PazBrowserPatcherState* pazBrowserPatcherState =  load_paz_browser_patcher_state(&paz_browser_patcher_state_n_files, operation);

        if (pazBrowserPatcherState != NULL)
        {

            int filesFound = 0;
            for (i = 0; i < metaFileInfo->fileBlocksCount; i++)
            {
                for (j = 0; j < paz_browser_patcher_state_n_files; j++)
                {
                    if (strcmpi(fileBlocks[i].fileName,pazBrowserPatcherState->fileName[j]) == 0)
                    {
                        fileBlocks[i].needPatch = 1;
                        fileBlocks[i].changeID = getFileColor(fileBlocks[i].hash,operation);

                        filesFound++;
                        break;
                    }
                    if (filesFound == paz_browser_patcher_state_n_files)
                    {
                        break;
                    }
                }
            }
        }

        for(i = 0; i < paz_browser_patcher_state_n_files; i++)
        {
            free(pazBrowserPatcherState->fileName[i]);
        }
        free(pazBrowserPatcherState);
    }


    while(1)
    {
        char* fileExt = "pac";
        if (operation == REMOVE_A_FILE || operation == RESTORE_A_FILE)
        {
            fileExt = menuSelectExt();
        }


        if (strcmpi(fileExt,"Back") == 0)
        {
            break;
        }
        while(1)
        {
            char* classSelected = menuSelectClass(&classSelected_idx);

            if (strcmpi(classSelected,"Back") != 0)
            {

                while(1)
                {
                    char* partSelected = menuSelectPart(&partSelected_idx);

                    if (strcmpi(partSelected,"Back") != 0)
                    {

                        while(menuSelectFile(classSelected,partSelected,fileExt,fileBlocks,metaFileInfo, operation))
                        {

                        }
                    }
                    else
                    {
                         break;
                    }
                }
                partSelected_idx = 0;
            }
            else
            {
                break;
            }
         }

        if (operation != REMOVE_A_FILE && operation != RESTORE_A_FILE)
        {
            break;
        }
    }


    return 0;
}

void previewFile(FileBlock* fileBlockSelected, FileBlock* fileBlocks, MetaFileInfo* metaFileInfo)
{

 if (fileHasExt(fileBlockSelected->fileName,"pac"))
 {


        int fileIsExtracted = 0;

         char* extractionPath = concatenate("patcher_resources\\extracted_files\\",substr(fileBlockSelected->fileName,0,strlen(fileBlockSelected->fileName)-3));
        extractionPath[strlen(extractionPath)-1] = '\\';


        if (!fileExists(concatenate(extractionPath,fileBlockSelected->fileName)))
        {
            fileIsExtracted = extractFile(fileBlockSelected);
        }
        else
        {
            printf("\nFile already extracted\n");
            fileIsExtracted = 1;
        }

        if (fileIsExtracted)
        {

                extractTexturesFrom(fileBlockSelected,fileBlocks,metaFileInfo);

                char* filePath = concatenate(getCurrentPath(),extractionPath);
                char* command = (char*) malloc((strlen("cd \"patcher_resources\\3d_converter\\\" & 3dconverter.exe \"%s\"") + strlen(filePath) + 64));
                filePath = concatenate(filePath,fileBlockSelected->fileName);
                charReplace(filePath,'/','\\');

                sprintf(command,"cd \"patcher_resources\\3d_converter\\\" & 3dconverter.exe \"%s\"",filePath);
                printf("Opening \"%s\" with 3D Object Converter...", fileBlockSelected->fileName);
                printf("\n\ncommand executed:\n%s\n\n", command);



                system(command);

                free(command);
                free(filePath);
        }
    }
    else
    {
        extractFileCustomPath(fileBlockSelected,"patcher_resources\\extracted_files\\",1);

        char* command = (char*) malloc(strlen(fileBlockSelected->fileName) + strlen("cd %s && %s") + 100);
        sprintf(command,"\"cd %s & %s","patcher_resources\\extracted_files\\",fileBlockSelected->fileName);

        system(command);
        free(command);
    }
}

char* getClassFolderPrefix(char* classSelected)
{
    if (strcmpi(classSelected,"Warrior") == 0)
    {
        return "1_PHM";
    }
    else if (strcmpi(classSelected,"Sorceress") == 0)
    {
        return "2_PHW";
    }
    else if (strcmpi(classSelected,"Ranger") == 0)
    {
        return "3_PEW";
    }
    else if (strcmpi(classSelected,"Berserker") == 0)
    {
        return "4_PGM";
    }
    else if (strcmpi(classSelected,"Tamer") == 0)
    {
        return "5_PBW";
    }
    else if (strcmpi(classSelected,"Blader(Musa)") == 0)
    {
        return "6_PKM";
    }
    else if (strcmpi(classSelected,"Valkyrie") == 0)
    {
        return "7_PVW";
    }
    else if (strcmpi(classSelected,"Wizard") == 0)
    {
       return "8_PWM";
    }
    else if (strcmpi(classSelected,"Witch") == 0)
    {
        return "8_PWW";
    }
    else if (strcmpi(classSelected,"Kunoichi") == 0)
    {
        return "13_PNW";
    }
    else if (strcmpi(classSelected,"Ninja") == 0)
    {
        return "13_PNM";
    }
    else if (strcmpi(classSelected,"Dark Knight") == 0)
    {
        return "15_PDW";
    }
    else if (strcmpi(classSelected,"Plum(Maehwa)") == 0)
    {
        return "22_PKWW";
    }
    else
    {
        printf("\nSelected class \"%s\" is has not the expected name\n", classSelected);
        system("PAUSE");
    }
    return "";
}

char* getPartFolderPrefix(char* partSelected)
{
    if (strcmpi(partSelected,"Upperbody") == 0)
    {
        return "9_upperbody";
    }
    else if (strcmpi(partSelected,"Lowerbody") == 0)
    {
        return "10_lowerbody";
    }
    else if (strcmpi(partSelected,"Hand") == 0)
    {
        return "11_hand";
    }
    else if (strcmpi(partSelected,"Foot") == 0)
    {
        return "12_foot";
    }
    else if (strcmpi(partSelected,"Helmet") == 0)
    {
        return "13_hel";
    }
    else if (strcmpi(partSelected,"Shoulder") == 0)
    {
        return "14_sho";
    }
    else if (strcmpi(partSelected,"Cloak") == 0)
    {
        return "19_cloak";
    }
    else if (strcmpi(partSelected,"Underwear") == 0)
    {
        return "38_underwear";
    }
    else if (strcmpi(partSelected,"Event Costume") == 0)
    {
        return "event_costume";
    }
     else if (strcmpi(partSelected,"Weapons") == 0)
    {
        return "weapon";
    }
     else if (strcmpi(partSelected,"Body Mesh") == 0)
    {
        return "nude";
    }
     else if (strcmpi(partSelected,"Head") == 0)
    {
        return "head";
    }
    else
    {
        printf("\nSelected part \"%s\" is has not the expected name\n", partSelected);
        system("PAUSE");
    }
    return "";
}



char* getClassPrefixFromMenuOption(char* classSelected)
{
    if (strcmpi(classSelected,"Warrior") == 0)
    {
        return "phm";
    }
    else if (strcmpi(classSelected,"Sorceress") == 0)
    {
        return "phw";
    }
    else if (strcmpi(classSelected,"Ranger") == 0)
    {
        return "pew";
    }
    else if (strcmpi(classSelected,"Berserker") == 0)
    {
        return "pgm";
    }
    else if (strcmpi(classSelected,"Tamer") == 0)
    {
        return "pbw";
    }
    else if (strcmpi(classSelected,"Blader(Musa)") == 0)
    {
        return "pkm";
    }
    else if (strcmpi(classSelected,"Valkyrie") == 0)
    {
        return "pvw";
    }
    else if (strcmpi(classSelected,"Wizard") == 0)
    {
       return "pwm";
    }
    else if (strcmpi(classSelected,"Witch") == 0)
    {
        return "pww";
    }
    else if (strcmpi(classSelected,"Kunoichi") == 0)
    {
        return "pnw";
    }
    else if (strcmpi(classSelected,"Ninja") == 0)
    {
        return "pnm";
    }
    else if (strcmpi(classSelected,"Dark Knight") == 0)
    {
        return "pdw";
    }
    else if (strcmpi(classSelected,"Plum(Maehwa)") == 0)
    {
        return "pkw";
    }
    else
    {
        printf("\nSelected class \"%s\" is has not the expected name\n", classSelected);
        system("PAUSE");
    }
    return "";
}


char* getPartPrefixFromMenuOption(char* partSelected)
{
    if (strcmpi(partSelected,"Upperbody") == 0)
    {
        return "_ub_";
    }
    else if (strcmpi(partSelected,"Lowerbody") == 0)
    {
        return "_lb_";
    }
    else if (strcmpi(partSelected,"Hand") == 0)
    {
        return "_hand_";
    }
    else if (strcmpi(partSelected,"Foot") == 0)
    {
        return "_foot_";
    }
    else if (strcmpi(partSelected,"Helmet") == 0)
    {
        return "_hel_";
    }
    else if (strcmpi(partSelected,"Shoulder") == 0)
    {
        return "_sho_";
    }
    else if (strcmpi(partSelected,"Cloak") == 0)
    {
        return "_cloak_";
    }
    else if (strcmpi(partSelected,"Underwear") == 0)
    {
        return "_uw_";
    }
    else if (strcmpi(partSelected,"Event Costume") == 0)
    {
        return "event_costume";
    }
     else if (strcmpi(partSelected,"Weapons") == 0)
    {
        return "weapon";
    }
     else if (strcmpi(partSelected,"Body Mesh") == 0)
    {
        return "nude";
    }
     else if (strcmpi(partSelected,"Head") == 0)
    {
        return "head";
    }
    else
    {
        printf("\nSelected part \"%s\" is has not the expected name\n", partSelected);
        system("PAUSE");
    }
    return "";
}


void compensateLength(char* fileName, int longestLength)
{
    int i = 0;

    /*if (strlen(fileName) > longestLength)
    {
        return;
    }*/

    for(i = 0; i < (longestLength - strlen(fileName)); i++)
    {
        printf(" ");
    }
}

int getCursorRow(int cursorPos)
{
    return ((int)(cursorPos/MAX_LINES));
}

int getCursorLine(int cursorPos)
{
    return ((int)(cursorPos- (getCursorRow(cursorPos)*MAX_LINES)));
}

void nextPage(int* pageStart, int* pageEnd, int nOptions)
{
    if ((*pageEnd) < nOptions)
    {
        (*pageStart) = (*pageEnd);
        (*pageEnd) += MAX_LINES* MAX_ROWS;
    }
}

void previousPage(int* pageStart, int* pageEnd)
{
    if ((*pageStart) - (MAX_LINES* MAX_ROWS) >= 0)
    {
        (*pageStart) -= (MAX_LINES* MAX_ROWS);
        (*pageEnd) -= MAX_LINES* MAX_ROWS;
    }
}

void goToPage(int pageNum, int* pageStart, int* pageEnd, int nOptions)
{
    int pageStartLocal = pageNum * (MAX_ROWS*MAX_LINES);
    int pageEndLocal = pageStartLocal + (MAX_ROWS*MAX_LINES);

    if(pageStartLocal < 0)
    {
        pageStartLocal = 0;
        pageEndLocal = pageStartLocal + (MAX_ROWS*MAX_LINES);
    }
    if (pageEndLocal > nOptions)
    {
        pageEndLocal = nOptions;
        pageStartLocal = pageEndLocal - (MAX_ROWS*MAX_LINES);
    }
    (*pageStart) = pageStartLocal;
    (*pageEnd) = pageEndLocal;
}

void goToLastPage(int* pageStart, int* pageEnd, int nOptions)
{
    (*pageStart) = nOptions - (MAX_ROWS*MAX_LINES);
    (*pageEnd) = nOptions;
}

int getCurrentPage(int cursor,int nOptions)
{
    return ((int)(cursor/(MAX_LINES*MAX_ROWS)) + 1);
}

int getTotalPages(int nOptions)
{
    return ((int)(nOptions/(MAX_LINES*MAX_ROWS)) + 1);
}



void uiMenuSelectFile(FileBlock** filesOnMenu,int nOptions, int cursor, int pageStart, int pageEnd, int operation, int selectAll, MetaFileInfo* metaFileInfo)
{
        int i = 0;
        int j = 0;
        int optionToDisplay = 0;

        int longestLength = 0;
        for(i = pageStart; i <= pageEnd; i++)
        {
             if (i > nOptions - 1)
            {
                break;
            }

            if (strlen(filesOnMenu[i]->fileName) > longestLength)
            {
                longestLength = strlen(filesOnMenu[i]->fileName);
            }
        }

        int necessaryWindowWitdh = (3 * (longestLength + strlen(" -->000 - [A][B]  "))) + 1;

        if (necessaryWindowWitdh > 120)
        {
            resizeWindow(necessaryWindowWitdh + 4,30);
        }
        else
        {
            resizeWindow(120,30);
        }

        if (operation != GET_TEXTURES)
        {
            char* operationName = getOperationName(operation);


            printf("[P]: ");printf("File currently patched in meta file\n");
            printf("[M]: ");printf("File marked to %s\n",operationName);
            printf("[C]: ");printf("File marked to %s across all classes\n",operationName );

            if (isAFemaleFile(filesOnMenu[0]->fileName))
            {
                printf("[G]: ");printf("File marked to %s across all female classes\n\n",operationName);
            }
            else
            {
                printf("[G]: ");printf("File marked to %s across all male classes\n\n",operationName);
            }

            printf("Remember: All the files you mark are saved to: \"\\Paz\\patcher_resources\\");printColor(PAZ_BROWSER_PATCHER_STATE_FILE_NAME[operation], YELLOW);
        }
        else
        {
            printMainHeader();
        }


        printf("\nPage %d - %d", getCurrentPage(cursor,nOptions),getTotalPages(nOptions));
        printf("\n");
        for(i = pageStart; i < nOptions; i++)
        {

            if (cursor == i)
            {
                printf("  ->%.3d - ",i+1);
            }
            else
            {
                printf("    %.3d - ",i+1);
            }



            if (filesOnMenu[i]->changeID == 1)
            {
                printf("[M]");
            }
            else if (filesOnMenu[i]->changeID == 2)
            {
                printf("[C]");
            }
            else if (filesOnMenu[i]->changeID == 3 || filesOnMenu[i]->changeID == 4)
            {
                printf("[G]");
            }
            else
            {
               printf("   ");
            }

            if (isPatched(filesOnMenu[i],metaFileInfo))
            {
                printf("[P]");
            }
            else
            {
                printf("   ");
            }

            if (cursor == i)
            {
                printf(" %s ",filesOnMenu[i]->fileName);
            }
            else
            {
                printf(" %s ",filesOnMenu[i]->fileName);
            }



            compensateLength(filesOnMenu[i]->fileName,longestLength);

            for (j = 1; j < MAX_ROWS; j++)
            {
                if (nOptions > (i + (j * MAX_LINES)))
                {
                    optionToDisplay = i + (j * MAX_LINES);

                    if (cursor == optionToDisplay)
                    {
                        printf("  ->%.3d - ",optionToDisplay+1);
                    }
                    else
                    {
                        printf("    %.3d - ",optionToDisplay+1);
                    }

                    if (filesOnMenu[optionToDisplay]->changeID == 1)
                    {
                        printf("[M]");
                    }
                    else if (filesOnMenu[optionToDisplay]->changeID == 2)
                    {
                        printf("[C]");
                    }
                    else if (filesOnMenu[optionToDisplay]->changeID == 3 || filesOnMenu[optionToDisplay]->changeID == 4)
                    {
                        printf("[G]");
                    }
                    else
                    {
                       printf("   ");
                    }

                      if (isPatched(filesOnMenu[optionToDisplay],metaFileInfo))
                    {
                        printf("[P]");
                    }
                    else
                    {
                        printf("   ");
                    }

                    if (cursor == optionToDisplay)
                    {
                        printf(" %s",filesOnMenu[optionToDisplay]->fileName);
                    }
                    else
                    {
                        printf(" %s",filesOnMenu[optionToDisplay]->fileName);
                    }



                    if (j < MAX_ROWS - 1)
                    {
                        compensateLength(filesOnMenu[optionToDisplay]->fileName,longestLength);
                    }
                }
            }
            printf("\n");


            if ((i + 1) >= (pageEnd - ((MAX_ROWS-1)*MAX_LINES)))
            {
                break;
            }
        }

        if (operation == GET_TEXTURES)
        {
            printf("\n                             ENTER - Get Textures from File\n\n");
            printf("ARROWS - Change Selected Option");
            printf("\nESC  - Go back\n");
        }
        else
        {
            if (selectAll == 0)
            {
                printf("\n                          SPACE - Mark file             A - Select All from this list\n");
            }
            else
            {
                printf("\n                          SPACE - Mark file             A - Unselect All from this list\n");
            }

            printf("\n       C - Mark this file across all classes      L - Preview File          ");
            printf("\n       G - Mark this file across the same gender  R - Unselect all files (including other classes)\n\n");
            printf("ARROWS - Change Selected Option       ENTER - Confirm and apply changes          ESC - Go back\n");
        }
}


void uiMenuSelectFileColor(FileBlock** filesOnMenu,int nOptions, int cursor, int pageStart, int pageEnd, int operation, int selectAll, MetaFileInfo* metaFileInfo)
{
        int i = 0;
        int j = 0;
        int optionToDisplay = 0;

        int longestLength = 0;
        for(i = pageStart; i <= pageEnd; i++)
        {
            if (i > nOptions - 1)
            {
                break;
            }
            if (strlen(filesOnMenu[i]->fileName) > longestLength)
            {
                longestLength = strlen(filesOnMenu[i]->fileName);
            }
        }


        int necessaryWindowWitdh = (3 * (longestLength + strlen(" -->000 - "))) + 1;

        if (necessaryWindowWitdh > 120)
        {
            resizeWindow(necessaryWindowWitdh + 4,30);
        }
        else
        {
            resizeWindow(120,30);
        }

        system("cls");


        if (operation != GET_TEXTURES)
        {
            char* operationName = getOperationName(operation);


            printf("\x1b[31m    red font files \x1b[0m: ");printf("File currently patched in meta file\n");
            printf("\x1b[43m Yellow background \x1b[0m: ");printf("File marked to %s\n",operationName);
            printf("\x1b[41m Red background    \x1b[0m: ") ;printf("File marked to %s across all classes\n",operationName );

            if (isAFemaleFile(filesOnMenu[0]->fileName))
            {
                printf("\x1b[45m Pink background   \x1b[0m: ");printf("File marked to %s across all female classes\n\n",operationName);
            }
            else
            {
                printf("\x1b[46m Cyan background   \x1b[0m: ");printf("File marked to %s across all male classes\n\n",operationName);
            }

            printf("Remember: All the files you mark are saved to: \"\\Paz\\patcher_resources\\");printColor(PAZ_BROWSER_PATCHER_STATE_FILE_NAME[operation], YELLOW);
        }
        else
        {
            printMainHeader();
        }


        printf("\nPage %d - %d", getCurrentPage(cursor,nOptions),getTotalPages(nOptions));
        printf("\n");
        for(i = pageStart; i < nOptions; i++)
        {
            if (filesOnMenu[i]->needPatch == 1)
            {
                if (cursor == i)
                {
                    // YELLOW BACKGROUND WITH CURSOR
                    if (filesOnMenu[i]->changeID == 1)
                    {
                        if (isPatched(filesOnMenu[i],metaFileInfo))
                        {
                            printf("\x1b[43m\x1b[31m  ->%.3d - %s\x1b[0m",i+1,filesOnMenu[i]->fileName);
                        }
                        else
                        {
                           printf("\x1b[43m  ->%.3d - %s\x1b[0m",i+1,filesOnMenu[i]->fileName);
                        }

                    }
                    else if (filesOnMenu[i]->changeID == 2)
                    {
                        if (isPatched(filesOnMenu[i],metaFileInfo))
                        {
                            // RED BACKGROUND WITH YELLOW LETTERS withC URSOR
                            printf("\x1b[41m\x1b[91m  ->%.3d - %s\x1b[0m",i+1,filesOnMenu[i]->fileName);
                        }
                        else
                        {
                            printf("\x1b[41m  ->%.3d - %s\x1b[0m",i+1,filesOnMenu[i]->fileName);
                        }
                    }
                    else if (filesOnMenu[i]->changeID == 3)
                    {
                        // PINK BACKGROUND WITH CURSOR
                        if (isPatched(filesOnMenu[i],metaFileInfo))
                        {
                            printf("\x1b[45m\x1b[91m  ->%.3d - %s\x1b[0m",i+1,filesOnMenu[i]->fileName);
                        }
                        else
                        {
                            printf("\x1b[45m  ->%.3d - %s\x1b[0m",i+1,filesOnMenu[i]->fileName);
                        }
                    }
                    else if (filesOnMenu[i]->changeID == 4)
                    {
                        // CYAN BACKGROUND WITH CURSOR
                        if (isPatched(filesOnMenu[i],metaFileInfo))
                        {
                            printf("\x1b[46m\x1b[31m  ->%.3d - %s\x1b[0m",i+1,filesOnMenu[i]->fileName);
                        }
                        else
                        {
                            printf("\x1b[46m  ->%.3d - %s\x1b[0m",i+1,filesOnMenu[i]->fileName);
                        }
                    }
                }
                else
                {
                    // YELLOW BACKGROUND
                    if (filesOnMenu[i]->changeID == 1)
                    {
                        if (isPatched(filesOnMenu[i],metaFileInfo))
                        {
                            printf("\x1b[43m\x1b[31m    %.3d - %s\x1b[0m",i+1,filesOnMenu[i]->fileName);
                        }
                        else
                        {
                           printf("\x1b[43m    %.3d - %s\x1b[0m",i+1,filesOnMenu[i]->fileName);
                        }

                    }
                    else if (filesOnMenu[i]->changeID == 2)
                    {
                        if (isPatched(filesOnMenu[i],metaFileInfo))
                        {
                            // RED BACKGROUND WITH YELLOW LETTERS
                            printf("\x1b[41m\x1b[91m    %.3d - %s\x1b[0m",i+1,filesOnMenu[i]->fileName);
                        }
                        else
                        {
                            printf("\x1b[41m    %.3d - %s\x1b[0m",i+1,filesOnMenu[i]->fileName);
                        }
                    }
                    else if (filesOnMenu[i]->changeID == 3)
                    {
                        // PINK BACKGROUND
                        if (isPatched(filesOnMenu[i],metaFileInfo))
                        {
                            printf("\x1b[45m\x1b[91m    %.3d - %s\x1b[0m",i+1,filesOnMenu[i]->fileName);
                        }
                        else
                        {
                            printf("\x1b[45m    %.3d - %s\x1b[0m",i+1,filesOnMenu[i]->fileName);
                        }
                    }
                    else if (filesOnMenu[i]->changeID == 4)
                    {
                        // CYAN BACKGROUND
                        if (isPatched(filesOnMenu[i],metaFileInfo))
                        {
                            printf("\x1b[46m\x1b[31m    %.3d - %s\x1b[0m",i+1,filesOnMenu[i]->fileName);
                        }
                        else
                        {
                            printf("\x1b[46m    %.3d - %s\x1b[0m",i+1,filesOnMenu[i]->fileName);
                        }
                    }
                }
            }
            else
            {
                if (cursor == i)
                {
                    if (isPatched(filesOnMenu[i],metaFileInfo))
                    {
                        // RED FOREGROUND WITH CURSOR
                        printf("  ->\x1b[31m%.3d - %s\x1b[0m",i+1,filesOnMenu[i]->fileName);
                    }
                    else
                    {
                        printf("  ->%.3d - %s",i+1,filesOnMenu[i]->fileName);
                    }

                }
                else
                {
                    if (isPatched(filesOnMenu[i],metaFileInfo))
                    {
                        // RED FOREGROUND
                        printf("\x1b[31m    %.3d - %s\x1b[0m",i+1,filesOnMenu[i]->fileName);
                    }
                    else
                    {

                        printf("    %.3d - %s",i+1,filesOnMenu[i]->fileName);
                    }

                }
            }

            compensateLength(filesOnMenu[i]->fileName,longestLength);

            for (j = 1; j < MAX_ROWS; j++)
            {
                if (nOptions > (i + (j * MAX_LINES)))
                {
                    optionToDisplay = i + (j * MAX_LINES);

                    if (cursor == optionToDisplay)
                    {
                        if (filesOnMenu[optionToDisplay]->needPatch == 1)
                        {
                            if (filesOnMenu[optionToDisplay]->changeID == 1)
                            {
                                if (isPatched(filesOnMenu[optionToDisplay],metaFileInfo))
                                {
                                    printf("\x1b[43m\x1b[31m  ->%.3d - %s\x1b[0m",optionToDisplay+1,filesOnMenu[optionToDisplay]->fileName);
                                }
                                else
                                {
                                    printf("\x1b[43m  ->%.3d - %s\x1b[0m",optionToDisplay+1,filesOnMenu[optionToDisplay]->fileName);
                                }

                            }
                            else if (filesOnMenu[optionToDisplay]->changeID == 2)
                            {
                                if (isPatched(filesOnMenu[optionToDisplay],metaFileInfo))
                                {
                                    printf("\x1b[41m\x1b[91m  ->%.3d - %s\x1b[0m",optionToDisplay+1,filesOnMenu[optionToDisplay]->fileName);
                                }
                                else
                                {
                                   printf("\x1b[41m  ->%.3d - %s\x1b[0m",optionToDisplay+1,filesOnMenu[optionToDisplay]->fileName);
                                }

                            }
                            else if (filesOnMenu[optionToDisplay]->changeID == 3)
                            {
                                if (isPatched(filesOnMenu[optionToDisplay],metaFileInfo))
                                {
                                    printf("\x1b[45m\x1b[91m  ->%.3d - %s\x1b[0m",optionToDisplay+1,filesOnMenu[optionToDisplay]->fileName);
                                }
                                else
                                {
                                   printf("\x1b[45m  ->%.3d - %s\x1b[0m",optionToDisplay+1,filesOnMenu[optionToDisplay]->fileName);
                                }

                            }
                            else if (filesOnMenu[optionToDisplay]->changeID == 4)
                            {
                                if (isPatched(filesOnMenu[optionToDisplay],metaFileInfo))
                                {
                                     printf("\x1b[46m\x1b[31m  ->%.3d - %s\x1b[0m",optionToDisplay+1,filesOnMenu[optionToDisplay]->fileName);
                                }
                                else
                                {
                                     printf("\x1b[46m  ->%.3d - %s\x1b[0m",optionToDisplay+1,filesOnMenu[optionToDisplay]->fileName);
                                }

                            }
                        }
                        else
                        {
                            if (isPatched(filesOnMenu[optionToDisplay],metaFileInfo))
                            {
                                  printf("  ->\x1b[31m%.3d - %s\x1b[0m",optionToDisplay+1,filesOnMenu[optionToDisplay]->fileName);
                            }
                            else
                            {
                                  printf("  ->%.3d - %s",optionToDisplay+1,filesOnMenu[optionToDisplay]->fileName);
                            }

                        }
                    }
                    else
                    {
                        if (filesOnMenu[optionToDisplay]->needPatch == 1)
                        {
                            if (filesOnMenu[optionToDisplay]->changeID == 1)
                            {
                                if (isPatched(filesOnMenu[optionToDisplay],metaFileInfo))
                                {
                                      printf("\x1b[43m\x1b[31m    %.3d - %s\x1b[0m",optionToDisplay+1,filesOnMenu[optionToDisplay]->fileName);
                                }
                                else
                                {
                                      printf("\x1b[43m    %.3d - %s\x1b[0m",optionToDisplay+1,filesOnMenu[optionToDisplay]->fileName);
                                }

                            }
                            else if (filesOnMenu[optionToDisplay]->changeID == 2)
                            {
                                if (isPatched(filesOnMenu[optionToDisplay],metaFileInfo))
                                {
                                      printf("\x1b[41m\x1b[91m    %.3d - %s\x1b[0m",optionToDisplay+1,filesOnMenu[optionToDisplay]->fileName);
                                }
                                else
                                {
                                      printf("\x1b[41m    %.3d - %s\x1b[0m",optionToDisplay+1,filesOnMenu[optionToDisplay]->fileName);
                                }

                            }
                            else if (filesOnMenu[optionToDisplay]->changeID == 3)
                            {
                                if (isPatched(filesOnMenu[optionToDisplay],metaFileInfo))
                                {
                                     printf("\x1b[45m\x1b[91m    %.3d - %s\x1b[0m",optionToDisplay+1,filesOnMenu[optionToDisplay]->fileName);
                                }
                                else
                                {
                                     printf("\x1b[45m    %.3d - %s\x1b[0m",optionToDisplay+1,filesOnMenu[optionToDisplay]->fileName);
                                }

                            }
                            else if (filesOnMenu[optionToDisplay]->changeID == 4)
                            {
                                if (isPatched(filesOnMenu[optionToDisplay],metaFileInfo))
                                {
                                     printf("\x1b[46m\x1b[31m    %.3d - %s\x1b[0m",optionToDisplay+1,filesOnMenu[optionToDisplay]->fileName);
                                }
                                else
                                {
                                     printf("\x1b[46m    %.3d - %s\x1b[0m",optionToDisplay+1,filesOnMenu[optionToDisplay]->fileName);
                                }

                            }
                        }
                        else
                        {
                            if (isPatched(filesOnMenu[optionToDisplay],metaFileInfo))
                            {
                                 printf("\x1b[31m    %.3d - %s\x1b[0m",optionToDisplay+1,filesOnMenu[optionToDisplay]->fileName);
                            }
                            else
                            {
                                 printf("    %.3d - %s",optionToDisplay+1,filesOnMenu[optionToDisplay]->fileName);
                            }

                        }
                    }

                    if (j < MAX_ROWS - 1)
                    {
                        compensateLength(filesOnMenu[optionToDisplay]->fileName,longestLength);
                    }
                }
            }
            printf("\n");

            if ((i + 1) >= (pageEnd - ((MAX_ROWS-1)*MAX_LINES)))
            {
                break;
            }
        }

        if (operation == GET_TEXTURES)
        {
            printf("\n                             ENTER - Get Textures from File\n\n");
            printf("ARROWS - Change Selected Option");
            printf("\nESC  - Go back\n");
        }
        else
        {
            if (selectAll == 0)
            {
                printf("\n                          SPACE - Mark file             A - Select All from this list\n");
            }
            else
            {
                printf("\n                          SPACE - Mark file             A - Unselect All from this list\n");
            }

            printf("\n       C - Mark this file across all classes      L - Preview File          ");
            printf("\n       G - Mark this file across the same gender  R - Unselect all files (including other classes)\n\n");
            printf("ARROWS - Change Selected Option       ENTER - Confirm and apply changes          ESC - Go back\n");
        }
}


